package java.util.concurrent;

import java.util.SortedMap;
import java.util.Set;
import java.util.NavigableSet;
import java.util.NavigableMap;

public interface ConcurrentNavigableMap<K, V> extends ConcurrentMap<K, V>, NavigableMap<K, V>
{
    public abstract ConcurrentNavigableMap<K, V> subMap(K p0, boolean p1, K p2, boolean p3);
    
    public abstract ConcurrentNavigableMap<K, V> headMap(K p0, boolean p1);
    
    public abstract ConcurrentNavigableMap<K, V> tailMap(K p0, boolean p1);
    
    public abstract ConcurrentNavigableMap<K, V> subMap(K p0, K p1);
    
    public abstract ConcurrentNavigableMap<K, V> headMap(K p0);
    
    public abstract ConcurrentNavigableMap<K, V> tailMap(K p0);
    
    public abstract ConcurrentNavigableMap<K, V> descendingMap();
    
    public abstract NavigableSet<K> navigableKeySet();
    
    public abstract NavigableSet<K> keySet();
    
    public abstract NavigableSet<K> descendingKeySet();
}
